Index: doc/README
===================================================================
--- doc/README	(revision 15a8c94f4e559bf7b9f201bd1b93e816948a5d43)
+++ doc/README	(revision 1999fe5eadc7c7575e33542da42b0e21b10366d9)
@@ -161,7 +161,4 @@
 file COPYING for this license.
 
-The Yahoo! library used by BitlBee is libyahoo2 <http://libyahoo2.sf.net/>,
-also licensed under the GPL.
-
 
 	BitlBee - An IRC to other chat networks gateway 
Index: doc/bitlbee.8
===================================================================
--- doc/bitlbee.8	(revision 15a8c94f4e559bf7b9f201bd1b93e816948a5d43)
+++ doc/bitlbee.8	(revision 1999fe5eadc7c7575e33542da42b0e21b10366d9)
@@ -39,6 +39,5 @@
 networks and acts as a gateway. Users can connect to the server
 with any normal IRC client and see their 'buddy list' in
-&bitlbee. It currently supports Oscar (AIM and ICQ),
-MSN, Jabber, Yahoo! and Twitter.
+&bitlbee.
 
 \fBbitlbee\fP should be called by
Index: doc/user-guide/Installation.xml
===================================================================
--- doc/user-guide/Installation.xml	(revision 15a8c94f4e559bf7b9f201bd1b93e816948a5d43)
+++ doc/user-guide/Installation.xml	(revision 1999fe5eadc7c7575e33542da42b0e21b10366d9)
@@ -36,5 +36,5 @@
 settings and buddy information. <filename>/var/lib/bitlbee/</filename>
 is the default value.</para></listitem>
-<listitem><para>msn, jabber, oscar, yahoo - By default, support for all
+<listitem><para>msn, jabber, oscar, twitter - By default, support for all
 these IM-protocols (OSCAR is the protocol used by both ICQ and AIM) will
 be compiled in. To make the binary a bit smaller, you can use these options
Index: doc/user-guide/commands.xml
===================================================================
--- doc/user-guide/commands.xml	(revision 15a8c94f4e559bf7b9f201bd1b93e816948a5d43)
+++ doc/user-guide/commands.xml	(revision 1999fe5eadc7c7575e33542da42b0e21b10366d9)
@@ -21,5 +21,5 @@
 			<description>
 				<para>
-					Adds an account on the given server with the specified protocol, username and password to the account list. Supported protocols right now are: Jabber, MSN, OSCAR (AIM/ICQ), Yahoo and Twitter. For more information about adding an account, see <emphasis>help account add &lt;protocol&gt;</emphasis>.
+					Adds an account on the given server with the specified protocol, username and password to the account list. For a list of supported protocols, use the <emphasis>plugins</emphasis> command. For more information about adding an account, see <emphasis>help account add &lt;protocol&gt;</emphasis>.
 				</para>
 
@@ -338,5 +338,5 @@
 		<description>
 			<para>
-				Requests IM-network-specific information about the specified user. The amount of information you'll get differs per protocol. For some protocols (ATM Yahoo! and MSN) it'll give you an URL which you can visit with a normal web browser to get the information.
+				Requests IM-network-specific information about the specified user. The amount of information you'll get differs per protocol. For some protocols it'll give you an URL which you can visit with a normal web browser to get the information.
 			</para>
 		</description>
@@ -1053,5 +1053,5 @@
 		<description>
 			<para>
-				Some protocols (MSN, Yahoo!, GTalk) can notify via IM about new e-mail. Since most people use their Hotmail/Yahoo! addresses as a spam-box, this is disabled default. If you want these notifications, you can enable this setting.
+				Some protocols can notify via IM about new e-mail. If you want these notifications, you can enable this setting.
 			</para>
 		</description>
Index: doc/user-guide/help.xml
===================================================================
--- doc/user-guide/help.xml	(revision 15a8c94f4e559bf7b9f201bd1b93e816948a5d43)
+++ doc/user-guide/help.xml	(revision 1999fe5eadc7c7575e33542da42b0e21b10366d9)
@@ -18,5 +18,5 @@
   <varlistentry><term>groupchats</term><listitem><para>How to work with groupchats on BitlBee</para></listitem></varlistentry>
   <varlistentry><term>nick_changes</term><listitem><para>Changing your nickname without losing any settings</para></listitem></varlistentry>
-  <varlistentry><term>smileys</term><listitem><para>A summary of some non-standard smileys you might find and fail to understand</para></listitem></varlistentry>
+  <varlistentry><term>identify_methods</term><listitem><para>A list of ways to (auto-)identify to your account</para></listitem></varlistentry>
 </variablelist>
 
@@ -49,5 +49,5 @@
   <varlistentry><term>groupchats</term><listitem><para>How to work with groupchats on BitlBee</para></listitem></varlistentry>
   <varlistentry><term>nick_changes</term><listitem><para>Changing your nickname without losing any settings</para></listitem></varlistentry>
-  <varlistentry><term>smileys</term><listitem><para>A summary of some non-standard smileys you might find and fail to understand</para></listitem></varlistentry>
+  <varlistentry><term>identify_methods</term><listitem><para>A list of ways to (auto-)identify to your account</para></listitem></varlistentry>
 </variablelist>
 
Index: doc/user-guide/misc.xml
===================================================================
--- doc/user-guide/misc.xml	(revision 15a8c94f4e559bf7b9f201bd1b93e816948a5d43)
+++ doc/user-guide/misc.xml	(revision 1999fe5eadc7c7575e33542da42b0e21b10366d9)
@@ -77,7 +77,10 @@
 
 <para>
-Some protocols (like Jabber) also support named groupchats. BitlBee now supports these too. You can use the <emphasis>chat add</emphasis> command to join them. See <emphasis>help chat add</emphasis> for more information.
-</para>
-
+Some protocols (like Jabber) also support named groupchats. BitlBee supports these too. You can use the <emphasis>chat add</emphasis> command to join them. See <emphasis>help chat add</emphasis> for more information.
+</para>
+
+<para>
+If you don't know the name of a named groupchat, you can try the <emphasis>chat list</emphasis> command to get a list of chatrooms from a server. See <emphasis>help chat list</emphasis> for usage instructions.
+</para>
 </sect1>
 
@@ -265,4 +268,38 @@
 everything in the handle up to the first @.
 </para>
+
+</sect1>
+
+<sect1 id="identify_methods">
+<title>Identifying to your BitlBee account</title>
+
+<para>There are several methods to identify (log in) to your registered BitlBee account. All of these are equivalent:</para>
+
+<variablelist>
+	<varlistentry>
+		<term>The 'identify' command</term>
+		<listitem><para>sent to &amp;bitlbee or root. See <emphasis>help identify</emphasis> for details.</para></listitem>
+	</varlistentry>
+	<varlistentry>
+		<term>/msg nickserv identify</term>
+		<listitem><para>Same as above, but sent to NickServ. Useful with some auto-identify scripts.</para></listitem>
+	</varlistentry>
+	<varlistentry>
+		<term>/nickserv or /ns</term>
+		<listitem><para>Same as above, but using the command aliases to NickServ.</para></listitem>
+	</varlistentry>
+	<varlistentry>
+		<term>Server password</term>
+		<listitem><para>A field in the server connection settings of your irc client.</para></listitem>
+	</varlistentry>
+	<varlistentry>
+		<term>SASL PLAIN</term>
+		<listitem><para>A newer method, good choice if your client supports it. (Note: "SASL" is <emphasis>not</emphasis> related to "SSL")</para></listitem>
+	</varlistentry>
+</variablelist>
+
+<para>To configure your client to auto-identify, the last two methods are recommended. SASL if you have it, but server password is often the easiest.</para>
+
+<para>Note: If you changed bitlbee.conf to have <emphasis>AuthMode = Closed</emphasis>, server password will be used for that instead. If you have never heard of that setting before, you can ignore it and just use it.</para>
 
 </sect1>
Index: doc/user-guide/quickstart.xml
===================================================================
--- doc/user-guide/quickstart.xml	(revision 15a8c94f4e559bf7b9f201bd1b93e816948a5d43)
+++ doc/user-guide/quickstart.xml	(revision 1999fe5eadc7c7575e33542da42b0e21b10366d9)
@@ -3,5 +3,5 @@
 
 <para>
-Welcome to BitlBee, your IRC gateway to ICQ, MSN, AOL, Jabber, Yahoo! and Twitter.
+Welcome to BitlBee, your IRC gateway to other instant messaging protocols.
 </para>
 
@@ -43,5 +43,9 @@
 
 <para>
-Other available IM protocols are msn, oscar, yahoo and twitter. OSCAR is the protocol used by ICQ and AOL. For more information about the <emphasis>account add</emphasis> command, see <emphasis>help account add</emphasis>.
+Other built-in IM protocols include msn, oscar and twitter. OSCAR is the protocol used by ICQ and AOL. Some protocols may be available as plugins that you can install, such as facebook, steam, discord and omegle. And you can get even more protocols by using the libpurple variant of BitlBee.
+</para>
+
+<para>
+For a list of currently supported protocols, use the <emphasis>plugins</emphasis> command. For more information about the <emphasis>account add</emphasis> command, see <emphasis>help account add</emphasis>.
 </para>
 
@@ -136,5 +140,5 @@
 
 <para>
-If you're still looking for something, please visit us in #bitlbee on the OFTC network (you can connect via irc.bitlbee.org), or mail us your problem/suggestion. Good luck and enjoy the Bee!
+If you're still looking for something, please visit us in #bitlbee on the OFTC network (irc.oftc.net). Good luck and enjoy the Bee!
 </para>
 